3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
14 git_broken_path_fix () {
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
50 if test -z "$GIT_QUIET"
56 if test -n "$OPTIONS_SPEC"; then
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
72 dashless=$(basename "$0" | sed -e 's/-/ /')
74 die "Usage: $dashless $USAGE"
77 if [ -z "$LONG_USAGE" ]
79 LONG_USAGE="Usage: $dashless $USAGE"
81 LONG_USAGE="Usage: $dashless $USAGE
87 -h|--h|--he|--hel|--help)
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
102 if test -z "${GIT_EDITOR:+set}"
104 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
107 eval "$GIT_EDITOR" '"$@"'
113 GIT_PAGER=$(git var GIT_PAGER)
120 eval "$GIT_PAGER" '"$@"'
124 GREP_OPTIONS= LC_ALL=C grep "$@"
128 GREP_OPTIONS= LC_ALL=C egrep "$@"
131 is_bare_repository () {
132 git rev-parse --is-bare-repository
136 cdup=$(git rev-parse --show-toplevel) &&
138 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
143 require_work_tree () {
144 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
145 die "fatal: $0 cannot be used without a working tree."
148 get_author_ident_from_commit () {
151 s/'\''/'\''\\'\'\''/g
153 s/^author \([^<]*\) <[^>]*> .*$/\1/
154 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
157 s/^author [^<]* <\([^>]*\)> .*$/\1/
158 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
161 s/^author [^<]* <[^>]*> \(.*\)$/\1/
162 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
167 encoding=$(git config i18n.commitencoding || echo UTF-8)
168 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
169 LANG=C LC_ALL=C sed -ne "$pick_author_script"
172 # Clear repo-local GIT_* environment variables. Useful when switching to
173 # another repository (e.g. when entering a submodule). See also the env
174 # list in git_connect()
175 clear_local_git_env() {
176 unset $(git rev-parse --local-env-vars)
179 # Make sure we are in a valid repository of a vintage we understand,
180 # if we require to be in a git repository.
181 if test -z "$NONGIT_OK"
183 GIT_DIR=$(git rev-parse --git-dir) || exit
184 if [ -z "$SUBDIRECTORY_OK" ]
186 test -z "$(git rev-parse --show-cdup)" || {
188 echo >&2 "You need to run this command from the toplevel of the working tree."
192 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
193 echo >&2 "Unable to determine absolute path of git directory"
196 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
199 # Fix some commands on Windows
202 # Windows has its own (incompatible) sort and find
209 is_absolute_path () {
218 is_absolute_path () {